"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SlidePanelPositions = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _bind = _interopRequireDefault(require("classnames/bind"));
var _terraThemeContext = _interopRequireDefault(require("terra-theme-context"));
var _terraVisuallyHiddenText = _interopRequireDefault(require("terra-visually-hidden-text"));
var _reactIntl = require("react-intl");
var _uuid = require("uuid");
var _SlidePanelModule = _interopRequireDefault(require("./SlidePanel.module.scss"));
var _excluded = ["intl", "isFullscreen", "isOpen", "fill", "mainAriaLabel", "mainContent", "panelAriaLabel", "panelContent", "panelBehavior", "panelPosition", "panelSize", "setSlidePanelRef"];
function _callSuper(t, o, e) { return o = (0, _getPrototypeOf2.default)(o), (0, _possibleConstructorReturn2.default)(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], (0, _getPrototypeOf2.default)(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
var cx = _bind.default.bind(_SlidePanelModule.default);
var SlidePanelPositions = exports.SlidePanelPositions = {
  START: 'start',
  END: 'end'
};
var propTypes = {
  /**
   * String that labels the Panel content area for screen readers.
   */
  panelAriaLabel: _propTypes.default.string,
  /**
   * String that labels the Main content area for screen readers.
   */
  mainAriaLabel: _propTypes.default.string,
  /**
   * The component to display in the main content area.
   */
  mainContent: _propTypes.default.node,
  /**
   * The component to display in the panel content area.
   */
  panelContent: _propTypes.default.node,
  /**
   * The style of panel presentation. One of `overlay`, `squish`.
   */
  panelBehavior: _propTypes.default.oneOf(['overlay', 'squish']),
  /**
   * The position at which the panel will be displayed. This property honors the current direction setting. One of `start`, `end`.
   */
  panelPosition: _propTypes.default.oneOf(['start', 'end']),
  /**
   * The size at which the panel will be displayed. One of `small`, `large`.
   */
  panelSize: _propTypes.default.oneOf(['small', 'large']),
  /**
   * Whether or not, when open, the panel should be displayed with the full width of the SlidePanel.
   */
  isFullscreen: _propTypes.default.bool,
  /**
   * Whether or not the panel should be displayed.
   */
  isOpen: _propTypes.default.bool,
  /**
   * Whether or not the SlidePanel should be sized relative to its parent container.
   */
  fill: _propTypes.default.bool,
  /**
   * @private
   * Callback function to set the slide panel ref.
   */
  setSlidePanelRef: _propTypes.default.func,
  /**
   * @private
   * Intl object injected from injectIntl
   */
  intl: _propTypes.default.shape({
    formatMessage: _propTypes.default.func,
    locale: _propTypes.default.string
  })
};
var defaultProps = {
  panelBehavior: 'overlay',
  panelPosition: SlidePanelPositions.END,
  panelSize: 'small'
};

/**
 * Checks whether or not the given node should be focusable.
 * If not focusable, find the closest parent element that is.
 * If it cannot find a focusable element, return undefined.
 */
var findFocusableElement = function findFocusableElement(node) {
  var focusableElementSelector = 'a[href]:not([tabindex=\'-1\']), area[href]:not([tabindex=\'-1\']), input:not([disabled]):not([tabindex=\'-1\']), ' + 'select:not([disabled]):not([tabindex=\'-1\']), textarea:not([disabled]):not([tabindex=\'-1\']), button:not([disabled]):not([tabindex=\'-1\']), ' + 'iframe:not([tabindex=\'-1\']), [tabindex]:not([tabindex=\'-1\']), [contentEditable=true]:not([tabindex=\'-1\'])';
  var focusableElements = (0, _toConsumableArray2.default)(document.body.querySelectorAll("".concat(focusableElementSelector))).filter(function (element) {
    return !element.hasAttribute('disabled') && !element.getAttribute('aria-hidden') && !!(element.offsetWidth || element.offsetHeight || element.getClientRects().length) && window.getComputedStyle(element).visibility !== 'hidden' && element.closest('[inert]') === null;
  });
  var currentNode = node;
  while (currentNode.parentElement) {
    if (focusableElements.includes(currentNode)) {
      return currentNode;
    }
    currentNode = currentNode.parentElement;
  }
  return undefined;
};
var SlidePanel = /*#__PURE__*/function (_React$Component) {
  function SlidePanel(props) {
    var _this;
    (0, _classCallCheck2.default)(this, SlidePanel);
    _this = _callSuper(this, SlidePanel, [props]);
    _this.setPanelNode = _this.setPanelNode.bind(_this);
    _this.mainNode = /*#__PURE__*/_react.default.createRef();
    _this.setDisclosingNode = _this.setDisclosingNode.bind(_this);
    _this.mainAriaDescribedByID = "detail-panel-warning-".concat((0, _uuid.v4)());
    return _this;
  }
  (0, _inherits2.default)(SlidePanel, _React$Component);
  return (0, _createClass2.default)(SlidePanel, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.isOpen && this.props.isOpen !== prevProps.isOpen) {
        // Save the disclosing node for returning focus when panel is closed
        var disclosingNode = findFocusableElement(document.activeElement);
        this.setDisclosingNode(disclosingNode);
        this.panelNode.focus();
        return;
      }
      if (!this.props.isOpen && this.props.isOpen !== prevProps.isOpen) {
        var _this$disclosingNode, _this$mainNode;
        if ((_this$disclosingNode = this.disclosingNode) !== null && _this$disclosingNode !== void 0 && _this$disclosingNode.focus) {
          // Return focus to the disclosing element
          this.disclosingNode.focus();
          return;
        }
        // The disclosing element doesn't exist or isn't focusable, return focus to the main div or body
        if ((_this$mainNode = this.mainNode) !== null && _this$mainNode !== void 0 && _this$mainNode.current) {
          this.mainNode.current.focus();
        } else {
          document.body.focus();
        }
      }
    }
  }, {
    key: "setPanelNode",
    value: function setPanelNode(node) {
      if (this.props.setSlidePanelRef) {
        this.props.setSlidePanelRef(node);
      }
      this.panelNode = node;
    }
  }, {
    key: "setDisclosingNode",
    value: function setDisclosingNode(node) {
      if (node) {
        this.disclosingNode = node;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        intl = _this$props.intl,
        isFullscreen = _this$props.isFullscreen,
        isOpen = _this$props.isOpen,
        fill = _this$props.fill,
        mainAriaLabel = _this$props.mainAriaLabel,
        mainContent = _this$props.mainContent,
        panelAriaLabel = _this$props.panelAriaLabel,
        panelContent = _this$props.panelContent,
        panelBehavior = _this$props.panelBehavior,
        panelPosition = _this$props.panelPosition,
        panelSize = _this$props.panelSize,
        setSlidePanelRef = _this$props.setSlidePanelRef,
        customProps = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var theme = this.context;
      var slidePanelClassNames = (0, _classnames.default)(cx('slide-panel', {
        'is-open': isOpen
      }, {
        'is-fullscreen': isFullscreen
      }, {
        fill: fill
      }, theme.className), customProps.className);
      var panelDiv = /*#__PURE__*/_react.default.createElement("div", {
        className: cx(['panel']),
        key: "panel",
        tabIndex: "-1",
        "aria-label": panelAriaLabel || intl.formatMessage({
          id: 'Terra.slidePanel.defaultPanelLabel'
        }),
        "aria-hidden": !isOpen ? 'true' : 'false',
        role: "region",
        ref: this.setPanelNode
      }, /*#__PURE__*/_react.default.createElement(_terraVisuallyHiddenText.default, {
        text: panelAriaLabel || intl.formatMessage({
          id: 'Terra.slidePanel.defaultPanelLabel'
        })
      }), panelContent);
      var mainDiv =
      /*#__PURE__*/
      // eslint-disable-next-line jsx-a11y/no-static-element-interactions, jsx-a11y/no-noninteractive-element-interactions
      _react.default.createElement("div", {
        className: cx('main'),
        key: "main",
        tabIndex: "-1",
        "aria-label": mainAriaLabel,
        "aria-describedby": this.mainAriaDescribedByID,
        "aria-hidden": isOpen && isFullscreen ? 'true' : 'false',
        ref: this.mainNode,
        role: "main"
      }, /*#__PURE__*/_react.default.createElement(_terraVisuallyHiddenText.default, {
        tabIndex: "-1",
        id: this.mainAriaDescribedByID,
        text: intl.formatMessage({
          id: 'Terra.slidePanel.discloseWarning'
        })
      }), mainContent);
      var content = panelPosition === SlidePanelPositions.START ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, panelDiv, mainContent && mainDiv) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, mainContent && mainDiv, panelDiv);
      return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({}, customProps, {
        className: slidePanelClassNames,
        "data-slide-panel-panel-behavior": panelBehavior,
        "data-slide-panel-panel-position": panelPosition,
        "data-slide-panel-panel-size": panelSize
      }), content);
    }
  }]);
}(_react.default.Component);
SlidePanel.propTypes = propTypes;
SlidePanel.defaultProps = defaultProps;
SlidePanel.contextType = _terraThemeContext.default;
var _default = exports.default = (0, _reactIntl.injectIntl)(SlidePanel);